import { POUCH_DEFAULT_QUALIFIER } from '../pouches/constants';
import PouchConfig from '../decorator/PouchConfig';
import * as CoreConstants from '@overflow/commons/core/constants';

class ConfigurationDefinition {
  protected _type: Function;
  protected _qualifier: string | symbol = undefined;
  protected _pouchMap: Map<string, PouchConfig>;

  public constructor(type: Function) {
    this._type = type;
    this._qualifier = POUCH_DEFAULT_QUALIFIER;
  }

  public get type(): Function {
      return this._type;
  }

  public get qualifier(): string | symbol {
      return this._qualifier;
  }

  public set qualifier(qualifier: string | symbol) {
    this._qualifier = qualifier;
  }

  public addPouch(propertyKey: string, pouchConfig: PouchConfig): void {
    if (undefined === this._pouchMap) {
      this._pouchMap = new Map();
    }
    let returnType: any = Reflect.getMetadata(CoreConstants.DESIGN_RETURNTYPE, this._type, propertyKey);

    if (undefined === pouchConfig.type) {
      pouchConfig.type = returnType;
    }

    this._pouchMap.set(propertyKey, pouchConfig);
  }

  public get Pouches(): Map<string, PouchConfig> {
      return this._pouchMap;
  }

}

export default ConfigurationDefinition;
