import ConfigurationDefinition from '../config/ConfigurationDefinition';

import createDecorator from '../../util/decorators/createDecorator';
import { getConfigurationDefinition } from '../util/metadata';

const Configuration = createDecorator('Configuration', {
  classDecorator: <TFunction extends Function>(target: TFunction): TFunction | void => {
    let configurationDefinition: ConfigurationDefinition = getConfigurationDefinition(target, false);
    if (undefined !== configurationDefinition) {
      throw new Error('Cannot apply @Configuration decorator multiple times.');
    }

    configurationDefinition = getConfigurationDefinition(target, true);

    return target;
  },

});

export default Configuration;
