import PouchConfig from './PouchConfig';
import ConfigurationDefinition from '../config/ConfigurationDefinition';
import createDecorator from '@overflow/commons/util/decorators/createDecorator';

import { getConfigurationDefinition } from '../util/metadata';


const Pouch = (pouchConfig: PouchConfig = {}) => createDecorator('Pouch', {
  methodDecorator: (target: Object, propertyKey: string, descriptor: TypedPropertyDescriptor<any>): TypedPropertyDescriptor<any> => {
    let configurationDefinition: ConfigurationDefinition = getConfigurationDefinition(target, false);
    if (undefined === configurationDefinition) {
      throw new Error('Cannot apply @Pouch decorator on the not @Configuration class.');
    }

    configurationDefinition.addPouch(propertyKey, pouchConfig);

    return descriptor;
  },
});

export default Pouch;
