import { PouchScope, POUCH_DEFAULT_QUALIFIER } from '../constants';

class PouchDefinition {
  protected _type: Object;
  protected _scope: PouchScope = PouchScope.SINGLETON;
  protected _qualifier: string | symbol = undefined;
  protected _postConstruct: Set<string> = undefined;
  protected _preDestroy: Set<string> = undefined;

  public constructor(type: Object) {
    this._type = type;
    this._qualifier = POUCH_DEFAULT_QUALIFIER;
  }

  public get type(): Object {
      return this._type;
  }

  public get scope(): PouchScope {
      return this._scope;
  }

  public set scope(scope: PouchScope) {
    this._scope = scope;
  }

  public get qualifier(): string | symbol {
      return this._qualifier;
  }

  public set qualifier(qualifier: string | symbol) {
    this._qualifier = qualifier;
  }

  public get postConstruct(): Set<string> {
      return this._postConstruct;
  }

  public addPostConstruct(postConstruct: string): void {
    if (undefined === this._postConstruct) {
      this._postConstruct = new Set();
    }
    this._postConstruct.add(postConstruct);
  }

  public get preDestroy(): Set<string> {
      return this._preDestroy;
  }

  public addPreDestroy(preDestroy: string): void {
    if (undefined === this._preDestroy) {
      this._preDestroy = new Set();
    }
    this._preDestroy.add(preDestroy);
  }

}

export default PouchDefinition;
