import * as METADATA from '../constants';
import { POUCH_DEFAULT_QUALIFIER } from '../constants';
import InjectConfig from './InjectConfig';
import PouchInjectDefinition from '../config/PouchInjectDefinition';
import createDecorator from '@overflow/commons/util/decorators/createDecorator';
import { getPouchInjectDefinition } from '../util/metadata';

const Inject = (injectConfig: InjectConfig = {}) => createDecorator('Inject', {
  propertyDecorator: (target: Object, propertyKey: string | symbol): void => {
    let pouchInjectDefinition: PouchInjectDefinition = getPouchInjectDefinition(target, true);
    pouchInjectDefinition.addInject(injectConfig, propertyKey);
  },
  parameterDecorator: (target: Object, propertyKey: string | symbol, parameterIndex: number): void => {
    let pouchInjectDefinition: PouchInjectDefinition = getPouchInjectDefinition(target, true);
    pouchInjectDefinition.addInject(injectConfig, propertyKey, parameterIndex);
  },

});


export default Inject;
