import * as METADATA from '../constants';
import PouchDefinition from '../config/PouchDefinition';
import createDecorator from '@overflow/commons/util/decorators/createDecorator';
import { getPouchDefinition } from '../util/metadata';

const Injectable = createDecorator('Injectable', {
  classDecorator: <TFunction extends Function>(target: TFunction): TFunction | void => {
    let pouchDefinition: PouchDefinition = getPouchDefinition(target, false);
    if (undefined !== pouchDefinition) {
      throw new Error('Cannot apply @injectable decorator multiple times.');
    }

    pouchDefinition = getPouchDefinition(target.prototype, true);

    return target;
  },

});


export default Injectable;
