import * as METADATA from '../constants';
import PouchDefinition from '../config/PouchDefinition';
import createDecorator from '@overflow/commons/util/decorators/createDecorator';
import { getPouchDefinition } from '../util/metadata';

const PreDestroy = createDecorator('PreDestroy', {
  methodDecorator: (target: Object, propertyKey: string, descriptor: TypedPropertyDescriptor<any>): TypedPropertyDescriptor<any> => {
    let pouchDefinition = getPouchDefinition(target, false);
    if (undefined === pouchDefinition) {
      throw new Error('Cannot apply @PreDestroy decorator on the not @Injectable class.');
    }
    pouchDefinition.addPreDestroy(propertyKey);
    return descriptor;
  },
});

export default PreDestroy;
