import * as METADATA from '../constants';
import PouchDefinition from '../config/PouchDefinition';
import createDecorator from '@overflow/commons/util/decorators/createDecorator';
import { getPouchDefinition } from '../util/metadata';

const Qualifier = (value: string | symbol) => createDecorator('Qualifier', {
  classDecorator: <TFunction extends Function>(target: TFunction): TFunction | void => {
    let pouchDefinition = getPouchDefinition(target, false);
    if (undefined === pouchDefinition) {
      throw new Error('Cannot apply @Qualifier decorator on the not @Injectable class.');
    }

    if (undefined !== pouchDefinition.qualifier) {
      throw new Error('Cannot apply @Qualifier decorator multiple times.');
    }
    pouchDefinition.qualifier = value;
    return target;
  },
});

export default Qualifier;
