import * as METADATA from '../constants';
import PouchDefinition from '../config/PouchDefinition';
import { PouchScope } from '../constants';
import createDecorator from '@overflow/commons/util/decorators/createDecorator';
import { getPouchDefinition } from '../util/metadata';

const Scope = (value: PouchScope = PouchScope.SINGLETON) => createDecorator('Scope', {
  classDecorator: <TFunction extends Function>(target: TFunction): TFunction | void => {
    let pouchDefinition = getPouchDefinition(target, false);
    if (undefined === pouchDefinition) {
      throw new Error('Cannot apply @Scope decorator on the not @Injectable class.');
    }
    pouchDefinition.scope = value;
    return target;
  },
});

export default Scope;
